<template>
  <div class="small">
    <select v-model="currentYear" @change="fetch()">
      <option
        v-for="(item, index) in year"
        :key="index"
      >
        {{ item }}
      </option>
    </select>
    <p>Выбрано: {{ currentYear }}</p>
    <bar-chart v-if="render" :chart-data="datacollection"></bar-chart>
  </div>
</template>

<script>
import BarChart from './BarChart.js'
import axios from 'axios'

// api currencylayer в бесплатном тарифе не дает получить значения от 2010 и до 2011 поэтому пришлось получать каждый месяц отдельно
// так же не смог  реализовать реактивное обновление поэтому пришлось костылить фикс ререндера страницы =)

export default {
  components: {
    BarChart
  },
  data () {
    return {
      render: true,
      currentYear: '2022',
      year: [],
      datacollection: {}
    }
  },
  mounted () {
    this.Data()
    this.years()
    // this.fetch()
  },
  methods: {
    getData (i) {
      axios.post('http://apilayer.net/api/historical?access_key=48e855e83a593d21924e9c604bcb853a&date=' + this.currentYear + '-' + [i].map(x => ('0' + x).slice(-2)).join(' ') + '-01' + '&currencies=RUB')
        .then((response) => {
          this.setData((i - 1), Object.values(response.data.quotes)[0])
          this.render = false
        })
        .catch((e) => {
          console.log(e)
        })
    },
    fetch () {
      for (let i = 1; i < 12; i++) {
        setTimeout(function () { this.getData(i) }.bind(this), 2000 * i)
      }
    },
    years () {
      for (let i = 2010; i <= 2022; i++) {
        this.year.push(i)
      }
    },
    setData (index, value) {
      console.log('hi - SetData')
      console.log(index, value)
      this.datacollection.datasets[0].data[index][1] = value
      this.$nextTick(this.view())
    },
    view () {
      setTimeout(function () { this.render = true }.bind(this), 20)
    },
    Data () {
      this.datacollection = {
        labels: ['Январь', 'Февраль', 'Март', 'Апрель', 'Май', 'Июнь', 'Июль', 'Август', 'Сентябрь', 'октябрь', 'Ноябрь', 'Декабрь'],
        datasets: [
          {
            label: 'USD/RUB',
            backgroundColor: '#f87979',
            data: [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0]]
          }
        ]
      }
    }
  }
}
</script>

<style>
  .small {
    max-width: 700px;
    margin:  auto auto;
  }
</style>
